require 'socket'

class Scanner
  attr_reader :log
  def initialize
    @opened = []
    @closed = []
    @log    = []
  end

  def port_open?(host, port)
    Socket.tcp(host, port, connect_timeout: 1) do |socket|
      @opened << port
    end
    rescue => error
      @log    << error.message
      @closed << port
  end

  def run(host, p_start, p_end)
    start  = p_start.to_i
    finish = p_end.to_i
    if p_end
      multi(host, start, finish)
    else
      port_open?(host, start)
    end
    status
  end
  
  def multi(host, p_start, p_end)
    (p_start..p_end).each { |port| Thread.new { port_open?(host, port) } } 
  end

  def status
    puts "Opened: #{@opened.join(', ')}" if @opened.length > 0
    puts "Closed: #{@closed.join(', ')}" if @closed.length > 0
  end
end

